#! /usr/bin/perl -w

#---------------------------------------------------------------------------------
#-----------------------     Control Unit Util 0.1 	--------------------------
#---------------------------------------------------------------------------------

# 0.2 ige / 23.01.2002 diverse Anpassungen...
# 0.1 ige / 10.06.2001 quick'n dirty  zum checken der Controller Schaltung

#---------------------------------------------------------------------------------
#----------------------- 	Module 		----------------------------------
#---------------------------------------------------------------------------------

use i2c_ser;
use strict; 
use Tk; 
use i2c_ser; 
use Tk::Dialog; 

#---------------------------------------------------------------------------------
#----------------------- 	Funcs 		----------------------------------
#---------------------------------------------------------------------------------

# Func's
sub Set8574($);	
sub ReadPCF();
sub SetPCF();

#---------------------------------------------------------------------------------
#----------------------- 	Variablen	----------------------------------
#---------------------------------------------------------------------------------

#PCF 8574
my @p1 = qw(0 0 0 0 0 0 0 0);		# Alles an 
my @p2 = qw(0 0 0 1 0 0 0 0);		# Alles an, bis auf Squelch
my @m8574ll;
my @m8574rr;


# Init PCF8591
my @ad  = qw(0 0 0 0);			# dig. 
my @adv = qw(0 0 0 0);			# V
my @m8591ll;
my @m8591rr;



my $setPCF	= 0.00;
my $pcf_refub 	= 2.55;
my $pcf_adr   	= 0;
my $opv 	= 4.00;		# Verstrkungs OP
my $intervall	= 500;		# mS 	

my $n = 0;
my $ltext;

#---------------------------------------------------------------------------------
#------------------------- 	INIT       ---------------------------------------
#---------------------------------------------------------------------------------

 # Port Delay setzen
 i2c_ser::set_port_delay(10); 
 my $iport  = i2c_ser::init_iic(0);
 my $iptext;

 print "Suche Interface...\n";
 if ($iport > 0) {
  $iptext = sprintf("I2C-Interface found on Port : 0x%0xh",$iport);
  print ("$iptext \n");
 } else {
   print "I2C-Interface nicht gefunden. \n"; 
   exit 1;
  }

 # AD/DA Wandler PCF8591 Datenpointer anlegen Mode 0 = 4x Eingang 
 my $pcf =i2c_ser::create8591(); 
 i2c_ser::pcf8591_init($pcf,0,$pcf_refub); 
 # Output setzen 0 V 
 i2c_ser::pcf8591_setda($pcf,0,$pcf_adr ); 

 # Init 
 Set8574(1);		# Output PCF 1 , Adr. 114
 Set8574(2);		# Output PCF 2 , Adr. 116	
 ReadPCF();		# Einlesen 

#---------------------------------------------------------------------------------
#----------------------- 	Main-TK     --------------------------------------
#---------------------------------------------------------------------------------
 
 # Main Window 
 my $TITLE="Control-Unit Util 0.1 / I. Gerlach , DH1AAD ";
 my $main = tkinit();# new MainWindow(-background => 'darkblue'); # Menue Zeile 
    $main-> title($TITLE);	# Title 
    $main-> geometry("600x400+0+0");	
    $main->configure(-borderwidth=>1); 
    $main-> minsize(200,200);				# Minimale erlaubte Groesse 

    # Top Dist.
    my $mTopF 	= $main->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-anchor=>'nw',-fill=>'x',-ipady=>10); 

    # Distance left side 
    my $mLeftF 	= $main->Frame(-relief=>'groove',-borderwidth=>0,-width=>15)->pack(-side=>'left',-anchor=>'nw',-fill=>'y');

    # Distance right side 
    my $mRightF = $main->Frame(-relief=>'groove',-borderwidth=>0,-width=>15)->pack(-side=>'right',-anchor=>'nw',-fill=>'y');

    # Distance bottom side 
    my $mBotF 	= $main->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'bottom',-anchor=>'sw',-fill=>'x',-ipady=>5);
 
    # Info Interface
    my $i2f    = $main->Frame(-relief=>'groove',-borderwidth=>1)->pack(-anchor=>'center',-fill=>'x',-ipady=>10,-expand=>0);   
    $i2f->Label(-text=>$iptext,-anchor=>'center',-foreground=>'red')->pack(-side=>"top",-anchor=>'w',-fill=>"x",-expand=>0);
 
    # PCF8574
    my $m8574F = $main->Frame(-label=>"PCF8574",labelPack=> [-side=>'top',anchor=>'n'],-relief=>'groove',
    			      -borderwidth=>1)->pack(-side=>'top',-anchor=>'n',-fill=>'x',-ipady=>10,-expand=>0);   

    my $m8574l = $m8574F->Frame(-relief=>'groove',-borderwidth=>1)->pack(-side=>'left', -fill=>'x',-expand=>1);
    my $m8574r = $m8574F->Frame(-relief=>'groove',-borderwidth=>1)->pack(-side=>'right',-fill=>'x',-expand=>1);
 
    # linke Seite  
    for($n=0;$n <8;$n++) {
     $ltext = "PCF8574 (Adr.114) P".$n.":";
     $m8574ll[$n] = $m8574l->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>1);
     $m8574ll[$n]->Label(-text=>$ltext,-width=>25,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>"x",-expand=>0);
     $m8574ll[$n]->Radiobutton(-text =>'Off',-value=>1 ,-variable=>\$p1[$n], -command=> sub { Set8574(1);})->pack(-side=>'left');
     $m8574ll[$n]->Radiobutton(-text =>'On' ,-value=>0 ,-variable=>\$p1[$n], -command=> sub { Set8574(1);})->pack(-side=>'left');  
    }

    # rechte Seite
    for($n=0;$n <8;$n++) {
     $ltext = "PCF8574 (Adr.116) P".$n.":";
     $m8574rr[$n] = $m8574r->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>1);
     $m8574rr[$n]->Label(-text=>$ltext,-width=>25,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>"x",-expand=>0);
     $m8574rr[$n]->Radiobutton(-text =>'Off',-value=>1 ,-variable=>\$p2[$n], -command=> sub {Set8574(2);})->pack(-side=>'left');
     $m8574rr[$n]->Radiobutton(-text =>'On' ,-value=>0 ,-variable=>\$p2[$n], -command=>  sub {Set8574(2);})->pack(-side=>'left');  
    }
    
    # PCF8591 
    my $m8591F = $main->Frame(-label=>"PCF8591",labelPack=> [-side=>'top',anchor=>'n'],-relief=>'groove',
    			      -borderwidth=>1)->pack(-side=>'top',-anchor=>'n',-fill=>'x',-ipady=>0,-expand=>0);   
    # V-Out
    my $m8591o	= $m8591F->Frame(-relief=>'groove',-borderwidth=>1)->pack(-side=>'bottom',-fill=>'x',-ipady=>0,-expand=>0);   
       $m8591o->Label(-text=>'Analog-Out :',-width=>15,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>"x",-expand=>0);
       $m8591o->Radiobutton(-text =>'0,00V',-value=>0 ,-variable=>\$setPCF, -command=> sub { SetPCF();})->pack(-side=>'left',-fill=>"x",-expand=>1);
       $m8591o->Radiobutton(-text =>'1,00V',-value=>1 ,-variable=>\$setPCF, -command=> sub { SetPCF();})->pack(-side=>'left',-fill=>"x",-expand=>1);
       $m8591o->Radiobutton(-text =>'2,00V',-value=>2 ,-variable=>\$setPCF, -command=> sub { SetPCF();})->pack(-side=>'left',-fill=>"x",-expand=>1);
       $m8591o->Radiobutton(-text =>'4,00V',-value=>4 ,-variable=>\$setPCF, -command=> sub { SetPCF();})->pack(-side=>'left',-fill=>"x",-expand=>1);

    my $m8591l = $m8591F->Frame(-relief=>'groove',-borderwidth=>1)->pack(-side=>'left', -fill=>'x',-expand=>1);
    my $m8591r = $m8591F->Frame(-relief=>'groove',-borderwidth=>1)->pack(-side=>'right',-fill=>'x',-expand=>1);
    
    # linke Seite  
    for($n=0;$n <2;$n++) {
     $ltext = "PCF8591 Ch".$n." :";
     $m8591ll[$n] = $m8591l->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>1);
     $m8591ll[$n]->Label(-text=>$ltext,-width=>15,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>"x",-expand=>0);
     $m8591ll[$n]->Label(-textvariable=>\$ad[$n],-width=>10,-anchor=>'w',-background=>'white',-foreground=>'black',-relief=>'groove')->pack(-side=>"left",-anchor=>'w',-fill=>"x",-expand=>0);
     $m8591ll[$n]->Label(-text=>'/',-width=>1,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>"x",-expand=>0);
     $m8591ll[$n]->Label(-textvariable=>\$adv[$n],-width=>10,-anchor=>'w',-background=>'white',-foreground=>'black',-relief=>'groove')->pack(-side=>"left",-anchor=>'w',-fill=>"x",-expand=>0);
     $m8591ll[$n]->Label(-text=>'V',-width=>5,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>"x",-expand=>0);
    }

    # rechte Seite  
    for($n=2;$n <4;$n++) {
     $ltext = "PCF8591 Ch".$n." :";
     $m8591rr[$n] = $m8591r->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>1);
     $m8591rr[$n]->Label(-text=>$ltext,-width=>15,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>"x",-expand=>0);
     $m8591rr[$n]->Label(-textvariable=>\$ad[$n],-width=>10,-anchor=>'w',-background=>'white',-foreground=>'black',-relief=>'groove')->pack(-side=>"left",-anchor=>'w',-fill=>"x",-expand=>0);
     $m8591rr[$n]->Label(-text=>'/',-width=>1,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>"x",-expand=>0);
     $m8591rr[$n]->Label(-textvariable=>\$adv[$n],-width=>10,-anchor=>'w',-background=>'white',-foreground=>'black',-relief=>'groove')->pack(-side=>"left",-anchor=>'w',-fill=>"x",-expand=>0);
     $m8591rr[$n]->Label(-text=>'V',-width=>5,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>"x",-expand=>0);
    }

    # Button - Frame 
    my $setup_f =$main->Frame(-relief=>'groove')->pack(-side=>'bottom'); 
    $setup_f->Button(-text=> 'Quit',-command=> sub { i2c_ser::deinit_iic();exit(0);})->pack(-side=>'left',-anchor=>'s',); 

    # Anzeige aktualisieren
    $m8574F->repeat($intervall,\&ReadPCF);
 
   # Main Loop 
   MainLoop; 

#---------------------------------------------------------------------------------
#----------------------- 	Subs        --------------------------------------
#---------------------------------------------------------------------------------

sub Set8574($) {
  my $p8574;
  if ($_[0] == 1) {
   $p8574 = $p1[7]*128+$p1[6]*64+$p1[5]*32+$p1[4]*16+$p1[3]*8+$p1[2]*4+$p1[1]*2+$p1[0]*1;
   i2c_ser::iic_tx_pcf8574($p8574 ,1);
   print "Value PCF8574 (Adr.:114) $p8574 \n";
  } else {
          $p8574 = $p2[7]*128+$p2[6]*64+$p2[5]*32+$p2[4]*16+$p2[3]*8+$p2[2]*4+$p2[1]*2+$p2[0]*1;
          i2c_ser::iic_tx_pcf8574($p8574 ,2);
          print "Value PCF8574 (Adr.:116) $p8574 \n";
         } 
 }   
   
   
 sub ReadPCF() {
  for ($n=0;$n<5;$n++) {
   $ad[$n]  = i2c_ser::pcf8591_readchan($pcf,$n,$pcf_adr ); 
   $adv[$n] = sprintf("%3.3f",($pcf_refub / 256 ) * $ad[$n]);
  }
 }
 
 sub SetPCF() {
  print "set $setPCF \n";
  i2c_ser::pcf8591_setda($pcf,($setPCF/$opv),$pcf_adr ); 
 }

#---------------------------------------------------------------------------------
#----------------------- 	End         --------------------------------------
#---------------------------------------------------------------------------------

