/***********************************************************************/
/*  IIC-Interface  Testprogramm f. TSA5055		               */
/*  V0.1  erstellt am  : 18.11.2001 / I. Gerlach                       */
/*  Dateiname          : test_tsa.c				       */
/*                                     				       */
/*  Aenderungen : 						       */
/*                                                                     */
/*                                                                     */
/* 					                               */
/* *********************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include "../i2c_ser/i2c_ser.h" 		// i2c Funktionen
//#include "../src/lcd.h"
#include "tsa5055.h"


int main(int argc, char *argv[]) {

 int test;
 int opt;
 int Adresse = 2; // Adresse = 6 = 198 Wobbler, 2 = Sat Tuner Mitel SP5055

 
  long f =     1600000000;
  // long f =   439250000 ;
  
   while((opt=getopt(argc, argv, ":f:")) != EOF)
    switch(opt)
   {
 
    case 'f':
     f=atol(optarg);
     printf("Parameter f= %ld \n",f);
     break;
   }  
       
 printf("*** ic-TSA5055 Test (c) Ingo Gerlach 11/2001 *** \n");
 set_port_delay(12);		// Portdelay 0-255 
 test = init_iic(0);		// Init ii2c 0, automatisch suchen
 printf("Suche i2c-Interface...");
 if (test) 
 {
  printf(" gefunden an Port 0x%03xh! \n",test);
 } else {
    printf("Interface nicht gefunden.\n");
    exit (0);
  }
//  set_strobe(1);			// Fr den Seriellen Port nur dummy, Parport -> wichtig !!! 
//  io_disable();				// 8 Bit I/O disablen auch nur ParPort
 
  test = tsa5055_init(&tsa5055,TSA5055_PLL,4000000);  // Daten initialisieren Datenstruktur, 
  				

  printf(" Init %d \n",tsa5055.cnt1);  						  
  test  = tsa5055_calc(&tsa5055,f,0);		// Berechnen der Teiler
  printf("Freq: %ld , Teiler n %d , Fres: %d\n",f,test,(test*TSA5055_STEP));
  printf("Freq: %ld , Teiler n %d , Fres: %d\n",f,test,((test*125000)/1000000));
  printf("Step: %d \n ",tsa5055.step);
  printf("Q   : %ld \n", tsa5055.quarz);
  printf(" Div 1 : %d \n",tsa5055.div1);
  printf(" Div 2 : %d \n",tsa5055.div2);
  printf(" Cont1 : %d \n",tsa5055.cnt1);
  printf(" Cont2 : %d \n",tsa5055.cnt2);
  printf("Ret: %d \n",tsa5055_send(&tsa5055,Adresse));
  printf("Read %d \n",tsa5055_read(Adresse));

test  = tsa5055_calc(&tsa5055,f,0);		// Berechnen der Teiler
tsa5055_send(&tsa5055,Adresse);

   test = tsa5055_read(Adresse);
 while (test < 64) {
    sleep(1);
    test = tsa5055_read(Adresse);
    printf("Unlock %10ld \n",f);
   }
   return 0;

		     
  for (f=1725000000;f<1795000000;) {
   printf("%10ld \n",f);
   test  = tsa5055_calc(&tsa5055,f,0);		// Berechnen der Teiler
   tsa5055_send(&tsa5055,Adresse);
   test = tsa5055_read(Adresse);
   while (test < 64) {
    sleep(1);
    test = tsa5055_read(Adresse);
    printf("Unlock %10ld ,Test: %d \n",f,test);
   }
   f=f+(8*TSA5055_STEP);
   // sleep(1);
  }


  printf("deinit %d\n",deinit_iic()); 
 return 0;
}
